"use strict";var juju={components:{}};describe("MachineViewMachine",function(){var services;beforeAll(function(done){YUI().use("machine-view-machine",function(){done()})});beforeEach(function(){services={getById:sinon.stub().returns({get:function get(val){switch(val){case"icon":return"icon.svg";break;case"fade":return false;break;case"hide":return false;break}}})}});it("can render a machine",function(){var removeUnit=sinon.stub();var selectMachine=sinon.stub();var machine={displayName:"new0",hardware:{cpuCores:2,cpuPower:200,disk:2048,mem:4096},series:"wily"};var units={filterByMachine:sinon.stub().returns([{agent_state:"started",displayName:"wordpress/0",id:"wordpress/0"},{agent_state:"started",displayName:"wordpress/1",id:"wordpress/1"}])};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,removeUnit:removeUnit,selected:false,selectMachine:selectMachine,services:services,showConstraints:true,type:"machine",units:units}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement("div",{className:"machine-view__machine machine-view__machine--machine",onClick:instance._handleSelectMachine,role:"button",tabIndex:"0"},React.createElement(juju.components.MoreMenu,{items:[{label:"Destroy",action:instance._destroyMachine}]}),React.createElement("div",{className:"machine-view__machine-name"},"new0"),React.createElement("div",{className:"machine-view__machine-hardware"},2," unit","s",", ","wily, "," ","2x2GHz, 4.00GB, 2.00GB"),React.createElement("ul",{className:"machine-view__machine-units"},React.createElement(juju.components.MachineViewMachineUnit,{key:"wordpress/0",machineType:"machine",removeUnit:removeUnit,service:services.getById(),unit:{agent_state:"started",displayName:"wordpress/0",id:"wordpress/0"}}),React.createElement(juju.components.MachineViewMachineUnit,{key:"wordpress/1",machineType:"machine",removeUnit:removeUnit,service:services.getById(),unit:{agent_state:"started",displayName:"wordpress/1",id:"wordpress/1"}})),React.createElement("div",{className:"machine-view__machine-drop-target"},React.createElement("div",{className:"machine-view__machine-drop-message"},"Add to ","new0")));assert.deepEqual(output,expected)});it("can render a machine in drop mode",function(){var selectMachine=sinon.stub();var machine={displayName:"new0",hardware:{cpuCores:2,cpuPower:200,disk:2048,mem:4096}};var units={filterByMachine:sinon.stub().returns([{agent_state:"started",displayName:"wordpress/0",id:"wordpress/0"},{agent_state:"started",displayName:"wordpress/1",id:"wordpress/1"}])};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{canDrop:true,connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),isOver:true,machine:machine,selected:false,selectMachine:selectMachine,services:services,showConstraints:true,type:"machine",units:units}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement("div",{className:"machine-view__machine machine-view__machine--drop "+"machine-view__machine--machine",onClick:instance._handleSelectMachine,role:"button",tabIndex:"0"},output.props.children);assert.deepEqual(output,expected)});it("can display a machine as uncommitted",function(){var selectMachine=sinon.stub();var machine={displayName:"new0",hardware:{},commitStatus:"uncommitted"};var units={filterByMachine:sinon.stub().returns([])};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,selected:false,selectMachine:selectMachine,services:services,type:"machine",units:units}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement("div",{className:"machine-view__machine "+"machine-view__machine--uncommitted machine-view__machine--machine",onClick:instance._handleSelectMachine,role:"button",tabIndex:"0"},output.props.children);assert.deepEqual(output,expected)});it("can display a deleted machine as uncommitted",function(){var selectMachine=sinon.stub();var machine={displayName:"new0",hardware:{},deleted:true};var units={filterByMachine:sinon.stub().returns([])};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,selected:false,selectMachine:selectMachine,services:services,type:"machine",units:units}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement("div",{className:"machine-view__machine "+"machine-view__machine--uncommitted machine-view__machine--machine",onClick:instance._handleSelectMachine,role:"button",tabIndex:"0"},output.props.children);assert.deepEqual(output,expected)});it("can hide units",function(){var removeUnit=sinon.stub();var selectMachine=sinon.stub();var machine={displayName:"new0",hardware:{cpuCores:2,cpuPower:200,disk:2048,mem:4096}};var units={filterByMachine:sinon.stub().returns([{deleted:false,displayName:"mysql/0",id:"mysql/0",service:"mysql"},{deleted:false,displayName:"wordpress/1",id:"wordpress/1",service:"wordpress"}])};var wordpress={get:function get(val){switch(val){case"icon":return"icon.svg";break;case"fade":return false;break;case"hide":return false;break}}};services.getById=function(val){switch(val){case"mysql":return{get:function get(val){switch(val){case"icon":return"icon.svg";break;case"fade":return true;break;case"hide":return true;break}}};break;case"wordpress":return wordpress;break}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,removeUnit:removeUnit,selected:false,selectMachine:selectMachine,services:services,type:"machine",units:units}));var expected=React.createElement("ul",{className:"machine-view__machine-units"},[React.createElement(juju.components.MachineViewMachineUnit,{key:"wordpress/1",machineType:"machine",removeUnit:removeUnit,service:wordpress,unit:{deleted:false,displayName:"wordpress/1",id:"wordpress/1",service:"wordpress"}})]);assert.deepEqual(output.props.children[3],expected)});it("can hide the constraints",function(){var removeUnit=sinon.stub();var selectMachine=sinon.stub();var machine={displayName:"new0",hardware:{cpuCores:2,cpuPower:200,disk:2048,mem:4096}};var units={filterByMachine:sinon.stub().returns([{agent_state:"started",displayName:"wordpress/0",id:"wordpress/0"},{agent_state:"started",displayName:"wordpress/1",id:"wordpress/1"}])};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,removeUnit:removeUnit,selected:false,selectMachine:selectMachine,services:services,showConstraints:false,type:"machine",units:units}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement("div",{className:"machine-view__machine machine-view__machine--machine",onClick:instance._handleSelectMachine,role:"button",tabIndex:"0"},React.createElement(juju.components.MoreMenu,{items:[{label:"Destroy",action:instance._destroyMachine}]}),React.createElement("div",{className:"machine-view__machine-name"},"new0"),undefined,React.createElement("ul",{className:"machine-view__machine-units"},React.createElement(juju.components.MachineViewMachineUnit,{key:"wordpress/0",machineType:"machine",removeUnit:removeUnit,service:services.getById(),unit:{agent_state:"started",displayName:"wordpress/0",id:"wordpress/0"}}),React.createElement(juju.components.MachineViewMachineUnit,{key:"wordpress/1",machineType:"machine",removeUnit:removeUnit,service:services.getById(),unit:{agent_state:"started",displayName:"wordpress/1",id:"wordpress/1"}})),React.createElement("div",{className:"machine-view__machine-drop-target"},React.createElement("div",{className:"machine-view__machine-drop-message"},"Add to ","new0")));assert.deepEqual(output,expected)});it("can render a machine with no hardware",function(){var selectMachine=sinon.stub();var machine={displayName:"new0",hardware:{}};var units={filterByMachine:sinon.stub().returns([{displayName:"wordpress/0",id:"wordpress/0"},{displayName:"wordpress/1",id:"wordpress/1"}])};var output=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,selected:false,selectMachine:selectMachine,services:services,showConstraints:true,type:"machine",units:units}));var expected=React.createElement("div",{className:"machine-view__machine-hardware"},2," unit","s",", ",undefined," ","hardware details not available");assert.deepEqual(output.props.children[2],expected)});it("can render a container",function(){var machine={displayName:"new0/lxc/0"};var units={filterByMachine:sinon.stub().returns([{agent_state:"started",displayName:"wordpress/0",id:"wordpress/0"},{agent_state:"started",displayName:"wordpress/1",id:"wordpress/1"}])};var removeUnit=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,removeUnit:removeUnit,services:services,showConstraints:true,type:"container",units:units}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement("div",{className:"machine-view__machine machine-view__machine--container",onClick:instance._handleSelectMachine,role:"button",tabIndex:"0"},React.createElement(juju.components.MoreMenu,{items:[{label:"Destroy",action:instance._destroyMachine}]}),React.createElement("div",{className:"machine-view__machine-name"},"new0/lxc/0"),undefined,React.createElement("ul",{className:"machine-view__machine-units"},React.createElement(juju.components.MachineViewMachineUnit,{key:"wordpress/0",machineType:"container",removeUnit:removeUnit,service:services.getById(),unit:{agent_state:"started",displayName:"wordpress/0",id:"wordpress/0"}}),React.createElement(juju.components.MachineViewMachineUnit,{key:"wordpress/1",machineType:"container",removeUnit:removeUnit,service:services.getById(),unit:{agent_state:"started",displayName:"wordpress/1",id:"wordpress/1"}})),React.createElement("div",{className:"machine-view__machine-drop-target"},React.createElement("div",{className:"machine-view__machine-drop-message"},"Add to ","new0/lxc/0")));assert.deepEqual(output,expected)});it("can destroy a machine",function(){var destroyMachines=sinon.stub();var selectMachine=sinon.stub();var machine={displayName:"new0",id:"new0"};var units={filterByMachine:sinon.stub().returns([{displayName:"wordpress/0",id:"wordpress/0"},{displayName:"wordpress/1",id:"wordpress/1"}])};var output=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:destroyMachines,dropUnit:sinon.stub(),machine:machine,selected:false,selectMachine:selectMachine,services:services,showConstraints:true,type:"machine",units:units}));output.props.children[0].props.items[0].action();assert.equal(destroyMachines.callCount,1);assert.deepEqual(destroyMachines.args[0][0],["new0"])});it("can remove a unit",function(){var machine={displayName:"new0/lxc/0"};var units={filterByMachine:sinon.stub().returns([{displayName:"wordpress/0",id:"wordpress/0"},{displayName:"wordpress/1",id:"wordpress/1"}])};var removeUnit=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewMachine.DecoratedComponent,{connectDropTarget:jsTestUtils.connectDropTarget,destroyMachines:sinon.stub(),dropUnit:sinon.stub(),machine:machine,services:services,type:"container",removeUnit:removeUnit,showConstraints:true,units:units}),true);var output=renderer.getRenderOutput();output.props.children[3].props.children[0].props.removeUnit();assert.equal(removeUnit.callCount,1)})});